//credits to aloshi for this epic explosive missile function
package MissileExplodePack {
function armor::onTrigger(%this, %obj, %triggerNum, %val)
{
	%DataBlockName = MissileVehicle.getId();
	%damageAmt = 900;
      %mount = %obj.getObjectMount();
      if(isObject(%mount))
      {
         if(%mount.getDataBlock() == %DataBlockName && %triggerNum == 0 && %val)
         {
            %client = %obj.client;
            if(isObject(%client) && !%client.player.getMountedImage(0)){

            if(getSimTime() - %mount.lastShotTime < 90000)
               return;
            
	%mount.damage(%obj, %obj.getPosition(), %damageAmt, Projectile);
            %mount.lastShotTime = getSimTime();

            return;
            }
         }
      }
      
      Parent::onTrigger(%this,%obj,%triggerNum,%val);
}

};
activatepackage(MissileExplodePack);

datablock AudioProfile(MissileExplodeSound)
{
   filename    = "./Missle_explode2.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock WheeledVehicleData(MissileVehicle)
{
	category = "Vehicles";
	displayName = " ";
	shapeFile = "./rideablemissile2.dts"; //"~/data/shapes/skivehicle.dts"; //
	emap = true;
	minMountDist = 3;
   
   numMountPoints = 1;
   mountThread[0] = "crouch";

	maxDamage = 2.00;
	destroyedLevel = 2.00;
	energyPerDamagePoint = 2;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	massCenter = "0 0 0";
   //massBox = "2 5 1";

	maxSteeringAngle = 0.9785;  // Maximum steering angle, should match animation
	integration = 4;           // Force integration time: TickSec/Rate
	tireEmitter = VehicleTireEmitter; // All the tires use the same dust emitter

	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 13;         // Far distance from vehicle
	cameraOffset = 7.5;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.4;
   collisionTol = 0.1;        // Collision distance tolerance
   contactTol = 0.1;

	useEyePoint = false;	

	defaultTire	  = jeepTire;
	defaultSpring = jeepSpring;
	flatTire	     = jeepFlatTire;
	flatSpring	  = jeepFlatSpring;

   numWheels = 0;

	// Rigid Body
	mass = 100;
	density = 5.0;
	drag = 0.6;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;        // Impacts over this invoke the script callback
	softImpactSpeed = 10;       // Play SoftImpact Sound
	hardImpactSpeed = 15;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;

	// Engine
	engineTorque = 12000; //4000;       // Engine power
	engineBrake = 2000;         // Braking when throttle is 0
	brakeTorque = 4000;        // When brakes are applied
	maxWheelSpeed = 20;        // Engine scale by current speed / max speed

	rollForce		= 900;
	yawForce		= 600;
	pitchForce		= 1000;
	rotationalDrag		= 0.2;
	DieonClick		= 1;

	// Energy
	maxEnergy = 100;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

   isSled = false;
   forwardThrust		= 6000;
	reverseThrust		= 4000;
	lift			= 100;
	maxForwardVel		= 40;
	maxReverseVel		= 40;
	horizontalSurfaceForce	= 130;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
	verticalSurfaceForce	= 130; 
	rollForce		= 2000;
	yawForce		= 4000;
	pitchForce		= 4000;
	rotationalDrag		= 0.9;
	stallSpeed		= 10;

//   forwardThrust		= 2000;
//	reverseThrust		= 2000;
//	lift			= 100;
//	maxForwardVel		= 70;
//	maxReverseVel		= 70;
//	horizontalSurfaceForce	= 100;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
//	verticalSurfaceForce	= 100; 
//	rollForce		= 6000;
//	yawForce		= 6000;
//	pitchForce		= 4000;
//	rotationalDrag		= 0.5;
//	stallSpeed		= 10;
//
//   forwardThrust		= 2500;
//	reverseThrust		= 500;
//	lift			= 15000;
//	maxForwardVel		= 60;
//	maxReverseVel		= 10;
//	horizontalSurfaceForce	= 500;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
//	verticalSurfaceForce	= 500; 
//	rollForce		= 5000;
//	yawForce		= 5000;
//	pitchForce		= 5000;
//	rotationalDrag		= 0.1;
//	stallSpeed		= 10;

	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
		
	//mediumSplashSound = "";
	//hardSplashSound = "";
	//exitSplashSound = "";
	
	// Sounds
	//   jetSound = ScoutThrustSound;
	//engineSound = idleSound;
	//squealSound = skidSound;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	//wheelImpactSound = slowImpactSound;

	explosion = MissileExplosion;
	justcollided = 0;

   uiName = "Missile ";
	rideable = true;
		lookUpLimit = 0.65;
		lookDownLimit = 0.45;

	paintable = true;
   
   damageEmitter[0] = VehicleBurnEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;

   damageEmitter[1] = VehicleBurnEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;

   numDmgEmitterAreas = 1;

   initialExplosionProjectile = MissilePreExplosionProjectile;
   initialExplosionOffset = 0;         //offset only uses a z value for now

   burnTime = 800;

   finalExplosionProjectile = MissileExplosionProjectile;
   finalExplosionOffset = 0.5;          //offset only uses a z value for now


   minRunOverSpeed    = 2;   //how fast you need to be going to run someone over (do damage)
   runOverDamageScale = 5;   //when you run over someone, speed * runoverdamagescale = damage amt
   runOverPushScale   = 1.2; //how hard a person you're running over gets pushed

   steeringUseStrafeSteering = false; //this vehicle has pitch control, so we can't use strafe steering

   minMissilecontrailspeed = 20;
};

function Missilevehicle::onadd(%this,%obj)
{ 
	MissilecontrailCheck(%obj);
	    
}

datablock ParticleData(MissileExplosionParticle)
{
   dragCoefficient      = 4;
   gravityCoefficient   = -5;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 2700;
   lifetimeVarianceMS   = 300;
   textureName          = "base/data/particles/cloud";
   spinSpeed		= 10.0;
   spinRandomMin		= -50.0;
   spinRandomMax		= 50.0;
   colors[0]     = "0.9 0.5 0.0 0.9";
   colors[1]     = "0.0 0.0 0.0 0.9";
   colors[2]     = "0.0 0.0 0.0 0.0";

   sizes[0]      = 18.0;
   sizes[1]      = 25.0;
   sizes[2]      = 22.0;

   times[0] = 0.0;
   times[1] = 0.4;
   times[2] = 1.0;

   useInvAlpha = true;
};
datablock ParticleEmitterData(MissileExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 95;
   velocityVariance = 1.0;
   ejectionOffset   = 3.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "MissileExplosionParticle";
};

datablock ParticleData(MissileExplosionRingParticle)
{
   dragCoefficient      = 8;
   gravityCoefficient   = -0.5;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 40;
   lifetimeVarianceMS   = 10;
   textureName          = "base/data/particles/star1";
   spinSpeed		= 10.0;
   spinRandomMin		= -500.0;
   spinRandomMax		= 500.0;
   colors[0]     = "1 0.5 0.0 0.5";
   colors[1]     = "0.9 0.0 0.0 0.0";
   sizes[0]      = 18;
   sizes[1]      = 23;

   useInvAlpha = false;
};
datablock ParticleEmitterData(MissileExplosionRingEmitter)
{
   lifeTimeMS = 50;

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 25;
   velocityVariance = 0.0;
   ejectionOffset   = 3.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "MissileExplosionRingParticle";
};

datablock ParticleData(MissileExplosionChunkParticle)
{
   dragCoefficient      = 0;
   gravityCoefficient   = 3;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 1400;
   lifetimeVarianceMS   = 1300;
   textureName          = "base/data/particles/chunk";
   spinSpeed		= 10.0;
   spinRandomMin		= -500.0;
   spinRandomMax		= 500.0;
   colors[0]     = "0.1 0.1 0.1 0.5";
   colors[1]     = "0.0 0.0 0.0 0.5";
   sizes[0]      = 2.7;
   sizes[1]      = 3;

   useInvAlpha = true;
};
datablock ParticleEmitterData(MissileExplosionChunkEmitter)
{
   lifeTimeMS = 25;

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 45;
   velocityVariance = 0.0;
   ejectionOffset   = 3.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "MissileExplosionChunkParticle";
};

datablock ExplosionData(MissileExplosion)
{
   debris = missileBitsDebris;
   debrisNum = 5;
   debrisNumVariance = 3;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 0;
   debrisThetaMax = 180;
   debrisVelocity = 80;
   debrisVelocityVariance = 60;

   lifeTimeMS = 250;
   explosionShape = "";
   soundProfile = MissileExplodeSound;

   lifeTimeMS = 0;

   particleEmitter = MissileExplosionEmitter;
   particleDensity = 30;
   particleRadius = 0.2;

   emitter[0] = MissileExplosionRingEmitter;
   emitter[1] = MissileExplosionChunkEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "30.0 31.0 30.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.9;
   camShakeRadius = 60.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 20;
   lightStartColor = "1 1 0 1";
   lightEndColor = "1 0 0 0";

   damageRadius = 32;
   radiusDamage = 10050;

   impulseRadius = 44;
   impulseForce = 40000;

   playerBurnTime = 5000;
};

datablock ProjectileData(MissileExplosionProjectile : vehicleExplosionProjectile)
{
   directDamage        = 90;
   radiusDamage        = 90;
   damageRadius        = 62;
   explosion           = MissileExplosion;

   directDamageType  = $DamageType::RocketExplosion;
   radiusDamageType  = $DamageType::RocketExplosion;

   explodeOnDeath		= 1;

   armingDelay         = 0;
   lifetime            = 0;

   uiName = "Missile Explosion";

   brickExplosionRadius = 34;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 70;             
   brickExplosionMaxVolume = 290;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 390;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

};


datablock ParticleData(MissilePreExplosionParticle)
{
   dragCoefficient      = 8;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   spinRandomMin = -90;
   spinRandomMax = 90;
   lifetimeMS           = 200;
   lifetimeVarianceMS   = 100;
   textureName          = "base/data/particles/chunk";
   colors[0]     = "0 0 0 1";
   colors[1]     = "0.2 0.2 1 0.2";
   sizes[0]      = 14.5;
   sizes[1]      = 14.5;
};

datablock ParticleEmitterData(MissilePreExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 8;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "MissilePreExplosionParticle";

   uiName = "Missile Preslposion";
};

datablock ExplosionData(MissilePreExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 500;

   particleEmitter = MissilePreExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   emitter[0] = MissileExplosionRingEmitter;
   emitter[1] = MissileExplosionChunkEmitter;

   shakeCamera = true;
   camShakeFreq = "320.0 322.0 320.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 1.5;
   camShakeRadius = 60.0;

   // Dynamic light
   lightStartRadius = 3;
   lightEndRadius = 0;
   lightStartColor = "00.0 0.2 0.6";
   lightEndColor = "0 0 0";

   brickExplosionRadius = 0;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;             
   brickExplosionMaxVolume = 0;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)
};

datablock ProjectileData(MissilePreExplosionProjectile : MissileExplosionProjectile)
{
   directDamage        = 0;
   radiusDamage        = 0;
   damageRadius        = 62;
   explosion           = MissilePreExplosion;

   explodeOnDeath		= 1;

   armingDelay         = 0;
   lifetime            = 0;

   uiName = "Missile Explosion (pre)";
};

datablock DebrisData(missileBitsDebris)
{
   emitters = "MissilecontrailEmitter";

	lifetime = 7.0;
	minSpinSpeed = -300.0;
	maxSpinSpeed = 300.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 5;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 1;
};

//Missilecontrail, mostly coded by ephi and kaje (?)

datablock ParticleData(MissilecontrailParticle)
{
   dragCoefficient      = 0;
   windCoefficient     = 0;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   spinRandomMin = -90;
   spinRandomMax = 90;
   lifetimeMS           = 400;
   lifetimeVarianceMS   = 0;
   textureName          = "base/data/particles/cloud";
   colors[0]     = "0.2 0.2 1 0.8";
   colors[1]     = "1 1 1 0.2";
   colors[2]     = "1 1 1 0.3";
   colors[3]     = "1 1 1 0.2";
   colors[4]     = "1 1 1 0";
   sizes[0]      = 1.2;
   sizes[1]      = 0.2;
   sizes[2]      = 0.3;
   sizes[3]      = 0.4;
   sizes[4]      = 0.5;
   times[0] = 0.0;
   times[1] = 0.3;
   times[2] = 0.4;
   times[3] = 0.5;
   times[4] = 0.9;

};

datablock ParticleEmitterData(MissilecontrailEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 3;
   velocityVariance = 1.0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "MissilecontrailParticle";
};

datablock ShapeBaseImageData(MissilecontrailImage1)
{
   shapeFile = "base/data/shapes/empty.dts";
	emap = false;

	mountPoint = 2;
   rotation = "1 0 0 -90";

	stateName[0]					= "Ready";
	stateTransitionOnTimeout[0]		= "FireA";
	stateTimeoutValue[0]			= 0.01;

	stateName[1]					= "FireA";
	stateTransitionOnTimeout[1]		= "Done";
	stateWaitForTimeout[1]			= True;
	stateTimeoutValue[1]			= 10000;
	stateEmitter[1]					= MissilecontrailEmitter;
	stateEmitterTime[1]				= 10000;

	stateName[2]					= "Done";
	stateScript[2]					= "onDone";
};
function MissilecontrailImage1::onDone(%this,%obj,%slot)
{
	%obj.unMountImage(%slot);
}


function MissilecontrailCheck(%obj)
{
//	return;
	if(!isObject(%obj))
		return;

	%speed = vectorLen(%obj.getVelocity());
	if(%speed < %obj.dataBlock.minMissilecontrailSpeed)
	{
		if(%obj.getMountedImage(2) !$= "")
		{
			%obj.unMountImage(2);
		}
	}
	else
	{
		if(%obj.getMountedImage(2) $= 0)
		{
			%obj.mountImage(MissilecontrailImage1,2);
		}
	}


	schedule(2000,0,"MissilecontrailCheck",%obj);
}
